﻿using System;

namespace _05_UebgMo_Warenwirtschaft
{
    // Programmieren Sie ein rudimentäres System zur Verwaltung beliebiger Produkte
    // Jedes Produkt soll die folgenden Eigenschaften besitzen, 
    //      int stueckzahl, double preis, string name
    // Es soll eigene (abstract oder nicht-abstract) Klassen für einzelne Produkte mit individuellen Datenfeldern geben: 
    // - Metallwaren mit den Unterklassen Schrauben und Nägel
    // - Milchprodukte mit den Unterklassen Joghurt und Butter 
    // - Gartenprodukte mit den Unterklassen Pflanzen und Container; Schreiben Sie für die Pflanze eine besondere
    //         Methode, die nur Pflanzen haben.
    // Erstellen Sie diese Klassen/Unterklassen mit geeigneten Konstruktoren, Basisklassenaufrufen, usw.
    // Entscheiden Sie, wie Sie vererben wollen (virtual/abstract)
    // Geben Sie für jede Klasse - wo sinnvoll - eine Überschreibung der ToString()-Methode an
    // Legen Sie in Main() ein Feld mit einem Objekt je Klasse an, geben Sie alle Elemente in einer Schleife aus
    // und schreiben Sie eine Methode, die z.B. nach der Pflanze über den Namen sucht und dieses Objekt zurückliefert
    // Rufen Sie dann für die Pflanze diese besondere Methode auf.
    abstract class Produkt
    {
        int stueckzahl;
        double preis;
        public string Name { get; protected set; }
        // protected: Die Methoden dieser Klasse und die Methoden der abgeleiteten Klassen
        // dürfen den set aufrufen.
        public Produkt(int stueckzahl, double preis, string name)
        {
            this.stueckzahl = stueckzahl;
            this.preis = preis;
            this.Name = name;
        }
        public double Wert() => preis * stueckzahl;
        //public abstract string Zeichnen();
    }
    abstract class Gartenprodukte : Produkt
    {
        public Gartenprodukte(int stückzahl, double preis, string name) 
            : base(stückzahl, preis, name) { }
    }
    class Pflanzen:Gartenprodukte
    {
        public enum Pflanzentyp { nutz, zier};
        Pflanzentyp typ;
        public Pflanzen(int stückzahl, double preis, string name, Pflanzentyp typ)
            :base(stückzahl, preis, name)
        {
            this.typ = typ;
        }
        public void Giessen() { }

    }
    class Program
    {
        static void Main(string[] args)
        {
            Produkt[] produkte = new Produkt[3];
            produkte[0] = new Pflanzen(10, 0.35, "Geranien", Pflanzen.Pflanzentyp.zier);
            produkte[1] = new Pflanzen(10, 0.55, "Salat", Pflanzen.Pflanzentyp.nutz);
            foreach (var item in produkte)
            {
                Console.WriteLine(item.Wert());
                if (item.Name == "Geranien")
                {
                    // item.Gießen();
                    Pflanzen p = (Pflanzen) item;
                    p.Giessen();
                    Pflanzen p2 = item as Pflanzen;
                    ((Pflanzen)item).Giessen();
                    if (item is Pflanzen p3)
                        p3.Giessen();
                }
            }
        }
    }
}
