﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace _06Ausnahmen
{
    class MeineFehlerKlasse : ArgumentOutOfRangeException
    {
        public int fehlerwert;
        public MeineFehlerKlasse(string Fehlertext, int Fehlerwert) 
            : base(Fehlertext) 
        { fehlerwert = Fehlerwert; }
    }
    class Program
    {
        static void funktion()
        {
            if (1 < 2)
                throw new MeineFehlerKlasse("Argumente außerhalb des Wertebereichs",2);
        }
        static void Main(string[] args)
        {
            try
            {
                try
                {
                    // Datei öffnen
                    funktion();
                    // Datei lesen
                    // Datei schließen
                }
                // Bei den Catches: 
                // Die spezifischeren Catches müssen vor den allgemeineren Catches stehen
                catch (MeineFehlerKlasse e)
                {
                    Console.WriteLine($"Fehler: {e.Message}, {e.fehlerwert }");
                    throw;   // throw (ohne Parameter) wirft das gefangene Fehlerobjekt weiter
                             // an den übergeordneten try-catch-Block
                }
                catch (ArgumentOutOfRangeException)
                {
                    Console.WriteLine("Argumente haben den falschen Wertebereich");
                }
                finally
                {
                    Console.WriteLine("Dieser Code wird immer ausgeführt");
                    // Zum Beispiel Dateien schließen, Ressourcen freigeben
                    // Bei ...
                    // Fehlerfreier Ausführung des try-Blocks
                    // Fehlerhafter Ausführung des try-Blockks mit und ohne catch 
                    //     (auch mit weiterem throw [mit und ohne Parameter] )
                }
            }
            catch (Exception)
            {
                Console.WriteLine("Sonstiger Fehler");
            }
        }
    }
}
