﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace _06Exceptions
{
    class Program
    {
        class MyAppExceptions : Exception
        {
            public MyAppExceptions(string Fehlertext="") : base(Fehlertext) { }
        }
        class MyInputExceptions : MyAppExceptions
        { }
        static int funktion2(int x)
        {
            //MyAppExceptions ex = new MyAppExceptions("Fehlertest");
            //throw ex;
            if (x < 0)
                throw new ArgumentOutOfRangeException("Fehler in funktion2");
            return x * x * x;
        }
        static int funktion(int x)
        {
            funktion2(x);
            if (x < 0)
                throw new MyAppExceptions("So nicht!!!");
            if (x == 0)
                throw new ArgumentOutOfRangeException("Argument darf nicht null sein");
            return x * x;

        }
        static void Main(string[] args)
        {
            try
            {
                funktion(-3);
                funktion(-2);
            }
            catch (MyAppExceptions q)
            {
                Console.WriteLine("Quadrierfehler");
            }
            catch (ArgumentOutOfRangeException e)
            {
                Console.WriteLine(e.Message);
                Console.WriteLine("--------");
                throw;    // Weiterwerfen der Exception
            }
            //catch (Exception e)
            //{
            //    Console.WriteLine("Allgemeiner Fehler");
            //}
            finally { }     // Code wird IMMER durchlaufen!


            // Unterschied zwischen
            //    try
            //    {
            //        doSomething();
            //    }
            //    catch
            //    {
            //        catchSomething();
            //    }
            //    finally
            //    {
            //        alwaysDoThis();
            //    }

            //  und ...

            //    try
            //    {
            //        doSomething();
            //    }
            //    catch
            //    {
            //        catchSomething();
            //        throw;
            //        return;
            //    }

            //    alwaysDoThis();
        }


        static void Main1(string[] args)
        {
            try
            {
                try
                {
                    Console.WriteLine("foo");
                    throw new Exception("exception");   //error occurs here
                }
                catch (Exception)
                {
                    Console.WriteLine("foo - catch");
                    throw;
                }
                finally   //will execute this as it is the first exception statement
                {
                    Console.WriteLine("foo's finally called");
                }
            }
            catch (Exception e)  // then this
            {
                Console.WriteLine("Exception caught. Message: " + e.Message);
            }
        }
    }
}
