﻿using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using System.Text;

namespace _07KeyValueList
{
    class KeyValuePaar<K, V> : IComparable<KeyValuePaar<K, V>>
        where K : IComparable<K>
    {
        public K key;
        public V val;
        public KeyValuePaar(K key, V val) { this.key = key; this.val = val; }
        public int CompareTo(KeyValuePaar<K, V> other)
            => key.CompareTo(other.key);
        public override string ToString() => $"{key}: {val}";
    }
}
