﻿using System;
using System.Collections.Generic;

namespace _07KeyValueList
{
    class Termin
    {
        public string was;
        public string wer;
        public Termin(string was, string wer) { this.was = was;this.wer = wer; }
        public override string ToString() => $"Termin: {was} mit {wer}";
    }
    class Program
    {
        static void Main(string[] args)
        {
            KeyValueListe<string, int> kvListe = new KeyValueListe<string, int>();
            kvListe["Wienkop"] = 1614;
            kvListe["Otsa"] = 1855;

            kvListe.Print();
            Console.WriteLine("-----------");
            kvListe["Otsa"] = 9999;
            kvListe.Print();
            Console.WriteLine("-----------");

            KeyValueListe<string, Termin> termine = new KeyValueListe<string, Termin>();
            termine["Wienkop"] = new Termin("IT-Proj", "Digitale Visitenkarte");
            termine.Print();
            //foreach (var item in termine)
            //{
            //    Console.WriteLine(item.val);
            //}

            List<Termin> termineMi = new List<Termin>();
            termineMi.Add(new Termin("08:00 Prog2-Vorlesung", "Gruppe-Wienkop"));
            termineMi.Add(new Termin("09:45 Dig Bildbearbeitung", "MA-MIN"));

            List<Termin> termineDi = new List<Termin>();
            termineDi.Add(new Termin("08:00 Prog2-Übung", "Gruppe-Wienkop"));
            termineDi.Add(new Termin("09:45 Prog2-Vorlesung", "Gruppe-Wienkop"));
            termineDi.Add(new Termin("11:30 Mitarbeiterbesprechung", "Jobbörse"));

            KeyValueListe<string, List<Termin>> terminverwaltung = new KeyValueListe<string, List<Termin>>();
            terminverwaltung["03.06.2020"] = termineMi;
            terminverwaltung["02.06.2020"] = termineDi;

            foreach (var tag in terminverwaltung)
            {
                Console.WriteLine($"\nTermine am {tag.key}:");
                foreach (var item in tag.val)
                {
                    Console.WriteLine(item);
                }
            }
        }
    }
}
