﻿using System;

namespace _09_DelegateVerkettung
{
    class Program
    {
        delegate void StringDelegate(ref string s);

        static StringDelegate stringdelegate;
        static string Ausgabe(string s)
        {
            stringdelegate?.Invoke(ref s);
            return s;
            //Console.WriteLine("------------");
        }
        static void InGrossbuchstaben(ref string s)
        {
            s = s.ToUpper();
        }
        static void AbZweitesZeichen(ref string s)
        {
            s= s.Substring(1);
        }
        static void Mitte(ref string s)
        {
            s = s.Substring(2, 3);  // Ab Zeichen an Pos. 2, 3 Zeichen
        }
        static void Main(string[] args)
        {
            StringDelegate tmp = delegate (ref string s) { s = s.Substring(1); };
            stringdelegate += InGrossbuchstaben;  // Ausführung in der Reihenfolge
            stringdelegate += tmp;                // des +=

            stringdelegate += Mitte;
            stringdelegate -= tmp; 
                    // Achtung!!! Anonyme Methoden können nicht entfernt werden
            stringdelegate += AbZweitesZeichen;

            Console.WriteLine(Ausgabe("Hallo-Welt"));
        }
    }
}
