﻿using System;

namespace _09DataDriven
{
    delegate void Seiteneffekt(int x);
    class MyData
    {
        private int data;
        public event Seiteneffekt ausgabe;
        public int Content
        {
            get
            {
                Console.WriteLine($"Get: {data}"); return data;
            }
            set
            {
                data = value;
                Console.WriteLine($"Set: {data}"); 
                ausgabe?.Invoke(data);
            }
        }
    }

    class Ausgabeaufbereitungen
    {
        public static void Textausgabe(int x)
        {
            Console.WriteLine(x);
        }
        public static void Balkenanzeige(int x)
        {
            for (int i = 0; i < x; i++)
            {
                Console.Write('x');
            }
            Console.WriteLine();
        }
    }
    class Program
    {
        
        static void Main(string[] args)
        {
            MyData x1 = new MyData();
            x1.ausgabe += Ausgabeaufbereitungen.Balkenanzeige;
            MyData x2 = new MyData();
            x2.ausgabe += Ausgabeaufbereitungen.Textausgabe;

            x1.Content = 10;
            x2.Content = 20;
            x1.Content += 5;  // x1.Content.set(x1.Content.Get ())
            x2.Content *= 3;
            x1.Content = (int)(8 * Math.PI);

        }
    }
}
