﻿using System;

namespace _10_RefDelegate
{
    class Program
    {
        delegate void MyFunction(ref double x);
        static MyFunction funkt;
        static void MeinQuadrieren(ref double xx)
        {
            Console.WriteLine("Mein Quadrieren");
            xx = xx * xx;
        }
        static void ZweiX(ref double x)
        {
            Console.WriteLine("ZweiX");
            x = 2 * x;
        }
        static void Plus1(ref double x)
        {
            Console.WriteLine("Plus1");
            x = 1 + x;
        }

        static void Main()
        {
            funkt += MeinQuadrieren;
            funkt += ZweiX;
            funkt += MeinQuadrieren;
            funkt += Plus1;

            double a = 2;       // Annahme: a liegt bei #100.000
            funkt(ref a);       // übergibt eine Ref. auf die Variable a 
                                // (Speicheradresse, wo der Wert von a abgelegt ist, hier #100.000)
            Console.WriteLine(a);
        }
    }
}
