﻿using System;
using System.Runtime.Intrinsics.X86;

namespace _11_UebgMoTransformator
{
    /* Schreiben Sie in Anlehnung an ApplyAll einen generischen Feld-Transformator, der Felder eines
     * beliebigen Typs nehmen und jeweils das Feld und die Feldelemente verändern kann. Dabei können mehrere 
     * Operationen aneinander gekettet werden. Das Feld kann dabei auch in seiner Anzahl vergrößert oder 
     * verkleinert werden.
     */

    class Program
    {
        delegate T MeineFkt<T>(T x);
        static T[] ApplyAll<T>(MeineFkt<T> fkt,  params T[] werte)
        {
            T[] erg = new T[werte.Length];
            Console.Write("APPLY ALL: ");
            for (int i = 0; i < werte.Length; i++)
            {
                erg[i] = fkt(werte[i]);
                Console.Write($"{erg[i]}  ");
            }
            Console.WriteLine();
            return erg;
        }

        //static string[] ApplyAll(MeineFkt<string> fkt, params string[] werte)
        //{
        //    T[] erg = new T[werte.Length];
        //    Console.Write("APPLY ALL: ");
        //    for (int i = 0; i < werte.Length; i++)
        //    {
        //        erg[i] = fkt(werte[i]);
        //        Console.Write($"{erg[i]}  ");
        //    }
        //    Console.WriteLine();
        //    return erg;
        //}

        static void Verdichten(ref string [] werte)
        {
            //int anz = werte.Length / 2;
            //string[] erg = new string[anz];
            //for (int i = 0; i < 2*anz; i+=2)
            //{
            //    erg[i / 2] = werte[i] + "&" + werte[i + 1];
            //}
            //werte = erg;
            string[] erg = new string[1];
            erg[0] = "ANTON&BERTA";
            erg[1] = "CLAUDIA&DIETER";
            werte = erg;
        }
        static void Main(string[] args)
        {
            Console.WriteLine("Hello World!");
            // Anton, Berta, Claudia, Dieter  --->
            // ANTON, BERTA, CLAUDIA, DIETER  --->
            // ANTON&BERTA, CLAUDIA&DIETER
            string[] namen = { "Anton", "Berta", "Claudia", "Dieter" };
            Verdichten(ref namen);
            foreach (var item in namen)
                Console.WriteLine(item);
        }
    }
}
