﻿using System;
using System.Collections;

namespace Aufgabe1Posts
{
    class Post
    {
        public string Name { get; }
        string post;
        public Post(string name, string post)
        {
            this.Name = name;
            this.post = post;
        }
        public override string ToString()
        {
            return Name + " ‐ " + post;
        }
    }
    class MeineListe : IEnumerable
    {
        class Element
        {
            public Post MyPost { get; }
            public Element next;
            public Element(Post post)
            {
                this.MyPost = post;
            }
        }
        Element anf = null;
        public void AddFront(Post post)
        {
            // 1. Leere Liste
            // 2. Es existiert mind. ein Element
            Element neuesElement = new Element(post);   // Neues Element anlegen
            if (anf == null)                            // 1.Fall: Leere Liste?
                anf = neuesElement;
            else
            {
                neuesElement.next = anf;                // 2. Fall
                anf = neuesElement;
            }
        }
        public static MeineListe operator +(MeineListe l1, Post post)
        {
            l1.AddFront(post);
            return l1;
        }
        //public void DeleteByName(string name)
        //{
        //    // leere Liste ohne Elemente
        //    if (anf == null)
        //        return;
        //    if (anf.MyPost.Name.CompareTo(name) == 0)
        //    {
        //        anf = anf.next;
        //    }
        //    else
        //    {
        //        Element item = anf;
        //        while (item.next != null && item.next.MyPost.Name.CompareTo(name) != 0)
        //            item = item.next;
        //        if (item.next != null)
        //        {
        //            item.next = item.next.next;
        //        }
        //    }
        //}
        public static MeineListe operator-(MeineListe l1, string name)
        {
            MeineListe lneu = new MeineListe();
            for (Element temp = l1.anf; temp != null; temp = temp.next)
            {
                if (temp.MyPost.Name != name)
                    lneu.AddFront(temp.MyPost);
            }
            return lneu;
        }
        public Post this[string name]
        {
            get
            {
                Post wert = null;
                for (Element temp = anf; temp != null; temp = temp.next)
                {
                    if (temp.MyPost.Name == name)
                    {
                        wert = temp.MyPost;
                        break;
                    }
                }
                return wert;
            }
        }
        public IEnumerator GetEnumerator()
        {
            for (Element item = anf; item != null; item = item.next)
            {
                yield return item.MyPost;
            }
        }
    }
    class Program
    {
        static void Main()
        {
            MeineListe postList = new MeineListe();

            postList += new Post("Max", "Klausuren sind anstrengend");
            postList += new Post("Max", "Aufgaben online");
            postList += new Post("Moritz", "Ferien sind cool");
            postList += new Post("Max", "Ferienbilder");

            Post lastPost = postList["Max"];
            if (lastPost != null)
            {
                Console.WriteLine("Last Post: " + lastPost);
            }
            Console.WriteLine("----------------");
            //postList -= new string("Max");
            postList-="Moritz";
            foreach (Post post in postList-"Max")
            {
                Console.WriteLine(post);
            }
        }
    }
}
