﻿using System;
using System.Runtime.CompilerServices;
using System.Security.Cryptography.X509Certificates;

namespace _11LambdaAusdruecke
{
    class Program
    {
        delegate int MeineFunktion1(int x, int y);
        delegate int MeineFunktion2();
        delegate int MeineFunktion3(params int[] x);

        static void TueEtwas1(MeineFunktion1 f1)
        {
            Console.WriteLine(f1(3, 5));
        }
        static void TueEtwas2(MeineFunktion2 f2)
        {
            Console.WriteLine(f2());
        }
        static void TueEtwas3(MeineFunktion3 f3)
        {
            Console.WriteLine(f3(1, 2, 3, 4, 5));
        }

        static int Summe(int[] f)
        {
            int sum = 0;
            foreach (var item in f)
                sum += item;
            return sum;
        }
        static void Main(string[] args)
        {
            TueEtwas1((x, y) => x + y);             // Zwei Parameter
            TueEtwas1((int x, int y) => x + y);     // Zwei Parameter, explizite Typangabe
            TueEtwas2(() => 11);                    // keine Parameter
            TueEtwas3(Summe);
            TueEtwas3((int[] f) => f.Length);
        }
    }
}
