﻿using System;

namespace _12Interfaces
{
    interface IStackable
    {
        void Push(int z);
        int Pop();
    }

    //abstract class Stack
    //{
    //    abstract public void Push(int z);
    //    abstract public int Pop();
    //}

    class Stack : IStackable
    {
        int[] speicher = new int[10];
        int count = 0;
        public int Pop() => speicher[--count];
        public void Push(int z)
        {
            speicher[count++] = z;
        }
        public int Count { get => count; }
    }
    class Program
    {
        static void Main(string[] args)
        {
            Stack stapel = new Stack();

            stapel.Push(10);
            stapel.Push(20);
            stapel.Push(30);
            Console.WriteLine(stapel.Pop());
            Console.WriteLine(stapel.Pop());
            
            Console.WriteLine(stapel.Count); //-- geht nicht, da stat.Typ von stapel IStack ist
            Console.WriteLine((stapel as Stack).Count);
        }
    }
}
 