﻿using System;
using System.Security.Cryptography;

namespace _12ToString
{
    class Person
    {
        public string name, vorname;
        public Person(string name, string vorname)
        {
            this.name = name; this.vorname = vorname;
        }
        public Person()
        {
            this.name = "xxx"; this.vorname = "yyy";
        }
        //public virtual string ToString() => Namespace.Klassenname
        public override string ToString() => $"(Person) {name}, {vorname}";
    }
    class SpecPerson : Person
    {
        int alter;
        public SpecPerson(string name, string vorname, int alter) : base(name, vorname) { this.alter = alter; }
        public override string ToString() => $"(SpecPerson) {base.ToString()}";
        public void TueEtwas() { }
        //public static explicit operator SpecPerson(Person p)
        //{
        //    return new SpecPerson(p.name, p.vorname, 20);
        //}
    }

    class SuperSpecPerson : SpecPerson
    {
        public SuperSpecPerson(string name, string vorname, int alter) : base(name, vorname, alter) { }
        public override string ToString() => $"(SpecSpecPerson) {base.ToString()}";
    }

    class Program
    {
        
        static void Main(string[] args)
        {
            SpecPerson p1 = new SpecPerson("Meier", "Anton", 10);   // Objekt wird bei #100.000 angelegt
            p1.TueEtwas();
            // p1: statischer Typ: SpecPerson, dynTyp: SpecPerson
            // Statischer Typ bestimmt die zur Verfügung stehenden Methoden
            // Dynamischer Typ bestimmt, welche Ausprägung (override) einer geerbten Methode genommen wird

            Person p2 = p1;         // p1: stat.Typ: Person, dyn.Typ: SpecPerson
            // Jede SpecPerson ist eine Person!

            Person p3 = new Person("Huber","Berta");
            // p2.TueEtwas();  -- geht nicht, da die Klasse Person keine TueEtwas() Methode enthält
            (p2 as SpecPerson).TueEtwas();

            SpecPerson pp = (p3 as SpecPerson);  // Konvertierung geht hier nicht, da p3 NUR eine Person (und keine
                    // SpecPerson ist; as liefert hier null zurück
            pp?.TueEtwas();

            Console.WriteLine(p1);
            Console.WriteLine(p2);
        }
    }
}
