﻿using System;

namespace _13Exceptions2
{
    class MyException : Exception
    {
        public int fehlercode { get; private set; }
        public MyException(string Message, int Fehlercode) : base(Message) { fehlercode = Fehlercode; }
    }
    class VecDimException : MyException
    {
        public VecDimException() : base("VecDim-Fehler", 5000) { }
    }

    class Program
    {
        static double skalprod(double[]a, double[]b)
        {
            if (a.Length != b.Length)
                throw new VecDimException();// ("Mein Fehler", 4000);
            return 1234.5;
        }
        static void Main(string[] args)
        {
            try
            {
                double[] aFeld = { 1, 2, 3 };
                double[] bFeld = { 3, 4, 5, 6};
                Console.WriteLine(  skalprod(aFeld, bFeld));
            }
            catch(VecDimException)
            {
                Console.WriteLine("VecDimFehler");
            }
            catch (MyException m)
            {
                Console.WriteLine($"My Exception  Mesg: {m.Message} Code: {m.fehlercode}");
            }
            catch   (Exception)
            {
                Console.WriteLine("Exception");
            }
        }
        static void Main2(string[] args)
        {
            try
            {
                try
                {
                    Console.WriteLine("Hallo");
                    //object o = null;
                    //o.ToString();
                    //int x = Convert.ToInt32("47Hallo");
                    //throw new NullReferenceException("Null Reference");
                    throw new MyException("Mein Fehler", 3000);
                    Console.WriteLine("Hier geht es weiter");
                }
                catch (MyException m)
                {
                    Console.WriteLine($"Mein Fehler ist aufgetreten: Message: {m.Message}, Fehlercode: {m.fehlercode}");
                    throw;
                }
                catch (NullReferenceException m)
                {
                    Console.WriteLine($"NullRef-Exception: Message: {m.Message}");
                }
            }
            catch (Exception e)
            {
                Console.WriteLine($"Allgemeiner Fehler: Message: {e.Message}");
            }
            Console.WriteLine("Ende von Main");
        }
    }
}
