﻿using System;
using System.Runtime.CompilerServices;

namespace _13MulticastDelegate
{
    class Program
    {
        delegate void MyDelegate();

        static void M1() { Console.WriteLine("M1"); }
        static void M2() { Console.WriteLine("M2"); }

        static void Main(string[] args)
        {
            MyDelegate m=null;
            MyDelegate n = null;

            n += M2;
            n+= M2;
            n += M1;

            m += M1;
            m += M1;
            m += n;   // Es werden alle in n gespeicherten Methoden nach m übernommen
            m += M1;
            m += M2;

            m();
            Console.WriteLine("----------------");

            m -= n;
            m();

            Console.WriteLine("----------------");

            m -= M2;
            m();

        }
    }
}
