﻿using System;

namespace _02VerketteteListe
{
    class Element
    {
        public string name;
        public Element(string name) { this.name = name; }
        public Element next;
    }
    class Program
    {
        static void Main(string[] args)
        {
            #region Intro
            //Element p1 = new Element("Anton");
            //Element p2 = new Element("Berta");
            //p1.next = p2;
            //p2 = new Element("Claudia");
            //p1.next.next = p2;
            #endregion
            // Erstes Element anlegen (noch ohne Verkettung)
            Element anf = new Element("Anton");
            Element ende = anf;  // Bei einem Element verweisen anf und ende auf dasselbe Objekt

            // Zweites Element anlegen und Verkettung vom bisherigen letzten Element
            // auf das neue Element erzeugen
            // Das neue Element ist nun das letzte Element in der Liste
            ende.next = new Element("Berta");
            ende = ende.next;

            for (int i = 1; i <= 10; i++)
            {
                ende.next = new Element("Claudia-"+i.ToString());
                ende = ende.next;
            }

            // Löschen des ersten Elements
            anf = anf.next;

            // Listendurchlauf mit Ausgeben der gespeicherten Namen
            for (Element tmp = anf; tmp != null; tmp = tmp.next)
            {
                Console.WriteLine(tmp.name);
            }

            // Listendurchlauf mit Suchen nach einem Namen ("Claudia-9")
            bool gefunden = false;
            for (Element tmp=anf; tmp!=null; tmp=tmp.next)
            {
                if (tmp.name == "Claudia-9")
                {
                    gefunden = true;
                    break;
                }
            }
            if (gefunden)
                Console.WriteLine("Element wurde gefunden");
            else
                Console.WriteLine("Kommt in der Liste nicht vor!");
         }
    }
}
