﻿using System;

namespace _04_UebgDi_Vererbung
{
    //Schreiben Sie drei Klassen Dreieck, Rechteck und Kreis mit jeweils einem Konstruktor
    //    Dreieck (int p1x, int p1y, int p2x, int p2y, int p3x, int p3y)
    //    Rechteck(int topX, int topY, int width, int height)
    //    Circle(int x, int y, int r)
    // Erstellen Sie in Main() EIN Feld in dem Sie diese Objekte miteinander speichern können -
    // hierfür ist die Erstellung einer gemeinsamen Basisklasse GrafischesObjekt erforderlich -
    // und schreiben Sie eine for/foreach-Schleife, die für die jeweiligen Feldeinträge
    // die entsprechende Ausgabe()-Methode aufruft. Hier reicht es aus, z.B. einfach Kreis(x,y,r) 
    // auszugeben.
    class GrafischesObjekt
    {
        public virtual void Print() { }
        // virtual ~ Diese Methode kann/darf in den abgeleiteten Klassen überschrieben werden
    }
    class Dreieck : GrafischesObjekt
    { }
    class Rechteck : GrafischesObjekt
    { }
    class Kreis : GrafischesObjekt
    {
        int x, y, r;
        public Kreis(int x, int y, int r)
        {
            this.x = x;
            this.y = y;
            this.r = r;
        }
        public override void Print()
        {
            // base.Print();  // Evtl. Nutzen der Funktionalität der Basisklasse
            Console.WriteLine($"Kreis: {x},{y}, radius: {r}");
        }

    }
    class Program
    {
        static void Main(string[] args)
        {
            GrafischesObjekt[] grObjekte = new GrafischesObjekt[5];
            grObjekte[0] = new Kreis(10,20, 5);
            //((Kreis) grObjekte[0]).Print();
            grObjekte[0].Print();
        }
    }
}
