﻿using System;

namespace _04VererbungGrafischeObjekte
{
    abstract class GrafischesObjekt
    {
        public abstract void Draw();
    }
    class Dreieck : GrafischesObjekt
    {
        int px1, py1, px2, py2, px3, py3;
        public override void Draw() { Console.WriteLine("Dreieck"); }
    }
    class Rechteck : GrafischesObjekt
    {
        int top, left, width, height;
        public override void Draw() { Console.WriteLine("Rechteck"); }
        //public abstract override void Draw();
    }
    class Quadrat : Rechteck
    {
        public override void Draw() { Console.WriteLine("Quadrat"); }
    }
    class Program
    {
        static void Main(string[] args)
        {
            GrafischesObjekt[] objFeld = new GrafischesObjekt[3];
            objFeld[0] = new Dreieck();
            objFeld[1] = new Rechteck();
            objFeld[2] = new Quadrat();
            foreach (var item in objFeld)
            {
                item.Draw();
            }
        }
    }
}
