﻿using System;

namespace _06_UebgDiExceptions
{
    // Erstellen Sie eine Dummy-Methode Funktion1, die einen try-catch Block enthält und 
    // eine zweite Dummy-Methode Funktion2, die wiederum einen try-catch Block besitzt und
    // eine Methode Funktion3, die bei ihrem Aufruf einen throw mit einer selbst
    // erstellten Fehlerklasse zur Folge hat. Main ruft Funktion1, Funktion1 ruft Funktion2 
    // und Funktion2 ruft Funktion3. Setzen Sie hinter die catches jeweils ein finally
    // Schreiben Sie entsprechende catch-Methoden, werfen Sie den Fehler weiter
    // und stellen Sie sicher, dass das Programm unter keinen Umständen mit einer Exception beendet wird!
    class MyAppExceptions : Exception
    {
        public int fehlerwert;
        public MyAppExceptions(string Fehlertext, int fehlerwert) : base(Fehlertext)
        {
            this.fehlerwert = fehlerwert;
        }
    }
    class Program
    {
        static void Funktion1()
        {
            Console.WriteLine("Funktion1");
            try
            {
                Funktion2();
                Console.WriteLine("Letzte Anweisung des try-Blocks von Funktion 1");
            }
            catch (ArgumentException)
            { }
            finally
            {
                Console.WriteLine("Finally von Funktion 1");
            }
            Console.WriteLine("Ende von Funktion1");
        }

        static void Funktion2()
        {
            Console.WriteLine("Funktion2");
            try
            {
                Funktion3();
                //Funktion3b();
                //if (errno != 0)
                //    Console.WriteLine("In Funktion 3b ist ein Fehler passiert");
                Console.WriteLine("Letzte Anweisung des try-Blocks von Funktion 2");
            }
            catch(MyAppExceptions e)   // Fängt MyAppExceptions und alle Exceptions, die 
                                       // von MyAppExceptions abgeleitet sind
            {
                Console.WriteLine($"catch in Funktion 2: {e.Message}, {e.fehlerwert}");
                throw;
            }
            finally
            {
                Console.WriteLine("Finally von Funktion 2");
            }
            Console.WriteLine("Ende von Funktion2");
        }
        static void Funktion3()
        {
            Console.WriteLine("Funktion3");
            int x = 2;
            if (1 < x)
                throw new DivideByZeroException("Fehler in F3");
                //throw new MyAppExceptions("Fehler in Funktion3", 4711);
            Console.WriteLine("Ende von Funktion3");
        }
        static int errno=0;
        static void Funktion3b()
        {
            int x = 0;
            errno = 9999;
            int y = 3 / x;
        }
        static void Main(string[] args)
        {
            bool fehler;
            do
            {
                // Init ...
                try
                {
                    fehler = false;
                    Funktion1();
                }
                catch (Exception)
                {
                    Console.WriteLine("Allgemeiner Fehler");
                    fehler = true;
                    // Neuinitialisierung ...
                }
            } while (fehler == true);
        }
    }
}
