﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace _06WPF_Ausnahmen
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                int a = Convert.ToInt32(tb1.Text);
                int b = Convert.ToInt32(tb2.Text);
                if (b > 1000)
                    throw new ArgumentException("Wert zu groß bei Eingabe 2");
                int c = Convert.ToInt32(tb3.Text);
                int d = Convert.ToInt32(tb4.Text);
                ErgLbl.Content = a + b + c + d;
            }
            catch (FormatException)
            {
                MessageBox.Show("Vermutlich eine falsche Eingabe. Bitte prüfen Sie die Textboxen");
            }
            catch (Exception ex)
            {
                MessageBox.Show("Fehler bei der Eingabe " + ex.Message);
            }
        }
    }
}
