﻿using System;

namespace MailServer
{
    class Program
    {
        static void mySpamChecker(Mail m)
        {
            string[] spamWords = { "Supersonderangebot", "BestBuy" };
            bool spam = false;
            foreach (var item in spamWords)
            {
                if (m.Header.Contains(item) || m.Body.Contains(item))
                {
                    spam = true;
                    break;
                }
            }
            if (spam)
            {
                m.Header = "[SPAM] " + m.Header;
            } 
        }
        static void myChecker2(Mail m)
        {
            if (m.Header.Contains("Newsletter"))
                m.Body = "Schon wieder ein Newsletter, nur nicht lesen";
        }
        static void Main(string[] args)
        {
            MailServer ms = new MailServer();
            ms.spamchecker += mySpamChecker;
            //ms.spamchecker += myChecker2;

            ms.Send(new Mail("BestBuy Newsletter", "Hier erhalten Sie unser Supersonderangebot"));
        }
    }
}

