﻿using System;

namespace _10OverrideNewDrawRectangle
{
    class FirmaA_GraficClass
    {
        public void DrawLine() { Console.WriteLine("GC: DrawLine"); }
        public virtual void DrawRectangle() { Console.WriteLine("GC: DrawRectangle"); }
    }
    class UnsereKlasse : FirmaA_GraficClass
    {
        public new virtual void DrawRectangle() { Console.WriteLine("UK: DrawRectangle"); }
    }

    class Program
    {
        static void Main(string[] args)
        {
            UnsereKlasse u = new UnsereKlasse();
            u.DrawRectangle();
            FirmaA_GraficClass gc = u;
            gc.DrawRectangle();
        }
    }
}
