﻿using System;
using System.Runtime.Intrinsics.X86;

namespace _11_UebgMoTransformator
{
    /* Schreiben Sie in Anlehnung an ApplyAll einen generischen Feld-Transformator, der Felder eines
     * beliebigen Typs nehmen und jeweils das Feld und die Feldelemente verändern kann. Dabei können mehrere 
     * Operationen aneinander gekettet werden. Das Feld kann dabei auch in seiner Anzahl vergrößert oder 
     * verkleinert werden.
     */
    delegate void Transformationen<T>(ref T[] x);
    class Program
    {
        static  void Verdichten(ref string [] werte)
        {
            //string[] erg = new string[1];
            //erg[0] = "Anton & Berta";
            //werte = erg;
            int anz = werte.Length / 2;
            string[] erg = new string[anz];
            for (int i = 0; i < 2 * anz; i += 2)
            {
                erg[i / 2] = werte[i] + "&" + werte[i + 1];
            }
            werte = erg;
        }
        static void Grossbuchstaben(ref string[] werte)
        {
            for (int i = 0; i < werte.Length; i++)
            {
                werte[i] = werte[i].ToUpper();
            }
        }

        static event Transformationen<string> Transform;

        static void Main(string[] args)
        {
            Console.WriteLine("Hello World!");
            // Anton, Berta, Claudia, Dieter  --->
            // ANTON, BERTA, CLAUDIA, DIETER  --->
            // ANTON&BERTA, CLAUDIA&DIETER
            string[] namen = { "Anton", "Berta", "Claudia", "Dieter","Ernst", "Friedrich"};

            Transform += Grossbuchstaben;
            Transform += Verdichten;

            Transform(ref namen);

            foreach (var item in  namen)
                Console.WriteLine(item);
        }
    }
}
